var React = require('react');
var createReactClass = require('create-react-class');
var MainSection = require('./MainSection.react');
var NavMenu = require('./NavMenu.react');
var SectionStore = require('../stores/SectionStore');
var NavSubMenuStore = require('../stores/NavSubMenuStore');
var NavStore = require('../stores/NavStore');
var NavMenuStore = require('../stores/NavMenuStore');
var NavActions = require('../actions/NavActions');
var Cookies = require('js-cookie');
var NavSubMenuItem = require('./navSubMenuItem.react.js');
var getState = function (menuState) {
  return {
    allSectionItems: SectionStore.getAll(),
    allNavMenuItems: NavMenuStore.getOnlyDate(),
    allNavItems: NavStore.getCommands(),
    menuToggle: NavStore.getToggleState(),
    sectionCategory: NavStore.getCategory()
  };
};

var OrthodoxPresenterApp = createReactClass({

  getInitialState: function () {
    return getState(true);
  },

  componentDidMount: function () {
    SectionStore.addChangeListener(this._onChange);
    NavStore.addChangeListener(this._onChange);
  },

  componentWillUnmount: function () {
    SectionStore.removeChangeListener(this._onChange);
    NavStore.removeChangeListener(this._onChange);
  },

  /**
   * @return {object}
   */
  render: function () {


    return (
      <div id="wrapper" className={this.state.menuToggle ? null : "toggled"}>
      <NavSubMenuItem  navMenuItemId = {'date'} attributes = {NavSubMenuStore.getAll() }/>
    </div>
    );
  },

  _onClick: function (e) {
    e.preventDefault();
    NavActions.toggleMenu();
  },
  /**
   * Event handler for 'change' events coming from stores
   */
  _onChange: function () {
    this.setState(getState(this.state.menuToggle));
  }

});

module.exports = OrthodoxPresenterApp;
